include \masm32\include\masm32rt.inc
include rsrc.inc

DialogProc proto :DWORD, :DWORD, :DWORD, :DWORD

.data

.data?

ICCEx					INITCOMMONCONTROLSEX			<>
hInstance				DWORD							?

.const

TB_PING					EQU								50
TB_TRACE				EQU								51
TB_TELNET				EQU								52
TB_SSH					EQU								53
TB_RDC					EQU								54

.code
    Start:

xor ebx, ebx
mov ICCEx.dwSize, sizeof ICCEx
mov ICCEx.dwICC, ICC_BAR_CLASSES OR ICC_STANDARD_CLASSES OR ICC_WIN95_CLASSES
	invoke InitCommonControlsEx, addr ICCEx
	invoke GetModuleHandle, ebx
mov hInstance, eax

	invoke DialogBoxParam, eax, IDD_DLG, ebx, addr DialogProc, ebx
	invoke ExitProcess, ebx

LoadToolbar proc hwnd:DWORD, nButtonX:DWORD, nButtonY:DWORD, BitmapID:DWORD
LOCAL hImageList:DWORD
LOCAL hToolbar:DWORD

LOCAL iNew:DWORD
LOCAL tbuttons[5]:TBBUTTON

	invoke GetDlgItem, hwnd, IDC_TOOLBAR
mov hToolbar, eax

	invoke ImageList_Create, nButtonX, nButtonY, ILC_COLOR OR ILC_MASK, 5, 0
mov hImageList, eax
	invoke SendMessage, hToolbar, TB_SETIMAGELIST, 0, hImageList
	invoke SendMessage, hToolbar, TB_LOADIMAGES, IDB_STD_SMALL_COLOR, HINST_COMMCTRL
	invoke SendMessage, hToolbar, TB_ADDSTRING, 0, addr arrszButtonText
mov iNew, eax

lea eax, tbuttons
xor ecx, ecx

ASSUME eax:PTR TBBUTTON

	@@:

mov edx, iNew
lea edx, [edx+ecx]
mov [eax].iBitmap, ecx

	.IF ecx == 0
		mov [eax].idCommand, TB_PING
	.ELSEIF ecx == 1
		mov [eax].idCommand, TB_TRACE
	.ELSEIF ecx == 2
		mov [eax].idCommand, TB_TELNET
	.ELSEIF ecx == 3
		mov [eax].idCommand, TB_SSH
	.ELSEIF ecx == 4
		mov [eax].idCommand, TB_RDC
	.ENDIF

mov [eax].fsState, TBSTATE_ENABLED
mov [eax].fsStyle, BTNS_AUTOSIZE
mov [eax].dwData, 0
mov [eax].iString, edx

add eax, sizeof tbuttons
inc ecx
cmp ecx, 5
jnz @b

ASSUME eax:NOTHING

	invoke SendMessage, hToolbar, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
	invoke SendMessage, hToolbar, TB_ADDBUTTONS, 5, addr tbuttons
	invoke SendMessage, hToolbar, TB_AUTOSIZE, 0, 0
	invoke ShowWindow, hToolbar, TRUE

ret
LoadToolbar endp

DialogProc proc hwndDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	.IF uMsg == WM_INITDIALOG
	
			invoke LoadToolbar, hwndDlg, 24, 22, BMP_TBR

		
	.ELSEIF uMsg == WM_CLOSE
		
			invoke EndDialog, hwndDlg, 0
	
	.ELSE
	
		mov eax, FALSE
		ret
		
	.ENDIF

mov eax, TRUE
ret
DialogProc endp

    end Start